clc
clear

% faithful data
data = importdata('bmi.txt');
[Nsamp Nk] = size(data);
data = data';

% initial times
nint = 10;

options = zeros(1,2);
options(1) = 1000;
options(2) = 1e-6;
  
ltc = zeros(2,nint);
paratemp = cell(1,nint);
paratemp1 = paratemp;
logltemp = zeros(2,nint);
for i=1:nint
 % initialize
  mixint = initsn1(data, 2);
  
  % compute MLE
  [Logl, Mix, Nit, Lld] = snmem(data, mixint, options);
  [pLogl, pMix, pNit, pLld] = plmesnmg(data, mixint, options);
  ltc(:,i) = [Logl pLogl]';
  paratemp{i} = Mix;
  paratemp1{i} = pMix;
  logltemp(:,i) = [Nit pNit]';

end

% resluts before 
mix0.order = 2;
mix0.mu = [19.6780 28.7258]';
mix0.lam = [1.6481 8.0715]';
mix0.sig = [12.6401 62.5603]'; %variance
mix0.pi = [0.5221 0.4779]';

[la lb] = max(ltc(1,:));
[lap lbp] = max(ltc(2,:));

[mix0.mu  paratemp{lb}.mu  paratemp1{lbp}.mu 
 mix0.sig paratemp{lb}.sig paratemp1{lbp}.sig 
 mix0.lam paratemp{lb}.lam paratemp1{lbp}.lam 
 mix0.pi  paratemp{lb}.pi  paratemp1{lbp}.pi]

[snmlog(data,mix0) snmlog(data,paratemp{lb}) snmlog(data,paratemp1{lbp})
 psnmlogg(data,mix0) psnmlogg(data,paratemp{lb}) psnmlogg(data,paratemp1{lbp})]


% figure
x = min(data)-3:(max(data)-min(data))/200:max(data)+3;
pdfml = snmpdf(x, paratemp{lb});
pdfpml = snmpdf(x, paratemp{lbp});
[ha hb] = hist(data,30);  
 
figure 
bar(hb,ha./Nsamp.*0.6);
hold on
plot(x,pdfml,'g^-');
hold on
plot(x,pdfml,'r*-');
hold off
legend('Sample bar','MLE','PMLE');




