function res = dismix(mix1, mix0)
% compute the distance between two mixing distribution
% x: mu
% y: sigma^2
% z: lambda

x = -5:0.1:10;
y = -15:0.1:1;
z = -10:0.1:5;

[Y,Z,X]=meshgrid(y,z,x);
XYZ=cat(3,X(:),Y(:),Z(:));

fun=@(abc,p)all(bsxfun(@ge,XYZ,permute(abc,[3,2,1])),3)*p.';

fval = abs(fun([mix0.mu'; log(mix0.sig')./5; log(mix0.lam')./2], mix0.pi') ...
    - fun([mix1.mu'; log(mix1.sig')./5; log(mix1.lam')./2], mix1.pi'));

Ua = unique(fval);
res = 0;

for j=1:length(Ua)
    res = res + sum(fval==Ua(j))*Ua(j);
end
res = res/1000;


