clc
clear

% Enzyme data
data = importdata('Enzyme.txt');
Nsamp = 245;
data = data';
data = data(:)';
data = data(1:Nsamp);

% initial times
nint =20;

ltc = zeros(1,nint);
ltc1 = ltc;
paratemp = cell(1,nint);
paratemp1 = paratemp;
logltemp = cell(1,nint);
logltemp1 = logltemp;
parfor i=1:nint
 % initialize
  mixint = initsn1(data, 2);
  
  % compute MLE
  options = zeros(1,2);
  options(1) = 1000;
  options(2) = 1e-7;
  [Logl, Mix, Nit, Lld] = snmem(data, mixint, options);
  [pLogl, pMix, pNit, pLld] = plmesnm(data, mixint, options);
  ltc(i) = Logl;
  ltc1(i) = pLogl;
  paratemp{i} = Mix;
  paratemp1{i} = pMix;
  logltemp{i} = Lld;
  logltemp1{i} = pLld;
end

% resluts before 
mix0.order = 2;
mix0.mu = [0.0949 0.7802]';
mix0.lam = [3.2780 6.6684]';
mix0.sig = [0.1331 0.715]'.^2; %variance
mix0.pi = [0.624 0.376]';
Logl0 = snmlog(data,mix0);
pLogl0 = psnmlog(data,mix0);

[la lb] = max(ltc);
[lap lbp] = max(ltc1);
Logl1 = snmlog(data,paratemp1{lbp});
pLogl1 = psnmlog(data,paratemp{lb});

[mix0.mu paratemp{lb}.mu paratemp1{lbp}.mu;
    mix0.lam paratemp{lb}.lam paratemp1{lbp}.lam;
    mix0.sig paratemp{lb}.sig paratemp1{lbp}.sig;
    mix0.pi paratemp{lb}.pi paratemp1{lbp}.pi]
[Logl0 ltc(lb) Logl1; pLogl0 pLogl1 ltc1(lb)]

% % figure
% x = -1:0.1:3;
% pdfnull = snmpdf(x, mix0);
% [ha hb] = hist(data,10);  
% pdfsn = snmpdf(x, paramax);
% 
% figure 
% bar(hb,ha/Nsamp);
% hold on
% plot(x,pdfnull,'g^-');
% hold on
% plot(x,pdfsn,'r*-');
% hold off
% legend('sample bar','result of Lin','skew normal fitting');
% 
% Logmax
% Logl0
% paramax.pi
% paramax.mu
% paramax.lam
% paramax.sig



