function mix = gmminit(data, K)
% initialize the parameters of Gaussian mixtures;
% data is N*1 vector;
% K is the mixture order;


% with K-means
options = zeros(1, 18);
options(5) = 1;	
options(14) = 5;

[centres, options, post] = kmeans(data, K, options);
while rank(post)<K
    [centres, options, post] = kmeans(data, K, options);
end
mixpro = sum(post,1)'./size(data,1);

Sigma = zeros(1,1,K);
for i=1:K
    mt = data(post(:,i)==1)-centres(i);
    nt = sum(post(:,i),1);
    Sigma(:,:,i)  = sum(mt.^2,1)/nt;
end

mix = struct('mu',centres,'Sigma',Sigma,'ComponentProportion',mixpro);
