function res = melrt(data, mix)
% compute the modified estimator for skew normal mixtures
% data is 1*n vector
% mix is the MLE

Lab = abs(mix.lam)>=30;
K = sum(Lab);

delta = chi2inv(0.95, K);
logl = snmlog(data, mix);
newlogl = logl - 0.5*delta;
        
switch K
    case {0}
        res = mix.lam;
        
    case {1}
        mixtemp = mix;
        for i=1:50
            mixtemp.lam(Lab) = 0.9*mixtemp.lam(Lab);
            logltemp = snmlog(data, mixtemp);
            err = logltemp - newlogl;
            if err<0
                mixtemp.lam(Lab) = 1.111*mixtemp.lam(Lab);
                res =  mixtemp.lam;
                return;
            elseif err>=0 && err<=0.1
                res =  mixtemp.lam;
                return;
            end
        end
        
    case {2}
       [V1 L1] = max(abs(mix.lam));
       [V2 L2] = min(abs(mix.lam));
       mixtemp = mix;
       for i=1:50
            mixtemp.lam(L1) = 0.9*mixtemp.lam(L1);
            logltemp = snmlog(data, mixtemp);
            err = logltemp - newlogl;
            if err<0
                mixtemp.lam(L1) = 1.111*mixtemp.lam(L1);
                break;
            elseif err>=0 && err<=0.1
                break;
            end
       end
       NS = 100;
       resmat = zeros(2, NS+1);
       resmat(:,1) = mixtemp.lam;
       delta = (mix.lam(L1) - mixtemp.lam(L1))./NS;
       for j=1:NS
           mixtemp.lam(L1) = mixtemp.lam(L1) + delta;
           for m=1:50
               mixtemp.lam(L2) = 0.9*mixtemp.lam(L2);
               logltemp = snmlog(data, mixtemp);
               err = logltemp - newlogl;
               if err<0
                  mixtemp.lam(L2) = 1.111*mixtemp.lam(L2);
                  break;
               elseif err>=0 && err<=0.1
                  break;
               end
           end
           resmat(:,j+1) = mixtemp.lam;
       end
       [md, ld] = max(sum(abs(bsxfun(@minus, resmat, mix.lam)),1));
       res = resmat(:,ld);
        
       
    otherwise
      error(['Unknown Value ', K]);
end

   

