clc
clear

% parallel setting
%Due to huge amount of computation, it is wise to use 
%more than 50 opretors for parallel computing

% load data
load data11

% settings
options = zeros(1,2);
options(1) = 1000;
options(2) = 1e-6;
  
Nn = length(Nsamp);
paratemp = cell(1,niter);
paratemp1 = paratemp;
paratemp2 = paratemp;
paratemp3 = paratemp;
parfor t=1:niter
    %t
  %random sample
  data1 = datamat1(t,:);
  data2 = datamat2(t,:);

  % n=100
  [Logl, Mix, Nit, Lld] = snmem(data1, mix0, options);
  paratemp{t} = Mix;
  [pLogl, pMix, pNit, pLld] = plmesnmg(data1, mix0, options);
  paratemp1{t} = pMix;
  
  % n=200
  [Logl1, Mix1, Nit1, Lld1] = snmem(data2, mix0, options);
  paratemp2{t} = Mix1;
  [pLogl1, pMix1, pNit1, pLld1] = plmesnmg(data2, mix0, options);
  paratemp3{t} = pMix1;
  
end
 

% result analysis
paramat = zeros(niter, 4*mix0.order);
paramat1 = paramat;
paramat2 = paramat;
paramat3 = paramat;
for h=1:niter
     paratemp{h} = labelswitch1(paratemp{h},mix0);
     paramat(h,:) = [paratemp{h}.mu' paratemp{h}.sig' paratemp{h}.lam' paratemp{h}.pi'];
     
     paratemp1{h} = labelswitch1(paratemp1{h},mix0);
     paramat1(h,:) = [paratemp1{h}.mu' paratemp1{h}.sig' paratemp1{h}.lam' paratemp1{h}.pi'];
     
     paratemp2{h} = labelswitch1(paratemp2{h},mix0);
     paramat2(h,:) = [paratemp2{h}.mu' paratemp2{h}.sig' paratemp2{h}.lam' paratemp2{h}.pi'];
     
     paratemp3{h} = labelswitch1(paratemp3{h},mix0);
     paramat3(h,:) = [paratemp3{h}.mu' paratemp3{h}.sig' paratemp3{h}.lam' paratemp3{h}.pi'];
     
end

% table for stat
T1 = [min(min(paramat(:,[3 4]),[],1)) sum(sum(paramat(:,[3 4])<1e-10,1))
    max(max(abs(paramat(:,[5 6])),[],1)) sum(sum(abs(paramat(:,[5 6]))>1e2,1))
    min(min(paramat1(:,[3 4]),[],1)) max(max(abs(paramat1(:,[5 6])),[],1))];

T2 = [min(min(paramat2(:,[3 4]),[],1)) sum(sum(paramat2(:,[3 4])<1e-10,1));
    max(max(abs(paramat2(:,[5 6])),[],1)) sum(sum(abs(paramat2(:,[5 6]))>1e2,1));
    min(min(paramat3(:,[3 4]),[],1)) max(max(abs(paramat3(:,[5 6])),[],1))];
 
% table for bias and std
bias0 = mean(bsxfun(@minus,paramat,para0),1);
sd0 = sqrt(mean(bsxfun(@minus,paramat,para0).^2,1));
bias1 = mean(bsxfun(@minus,paramat1,para0),1);
sd1 = sqrt(mean(bsxfun(@minus,paramat1,para0).^2,1));
tabl01 = [bias0' sd0' bias1' sd1'];

bias2 = mean(bsxfun(@minus,paramat2,para0),1);
sd2 = sqrt(mean(bsxfun(@minus,paramat2,para0).^2,1));
bias3 = mean(bsxfun(@minus,paramat3,para0),1);
sd3 = sqrt(mean(bsxfun(@minus,paramat3,para0).^2,1));
tabl02 = [bias2' sd2' bias3' sd3'];

bias00 = mean(bsxfun(@minus,log(paramat(:,3:4)),log(para0(3:4))),1);
sd00 = sqrt(mean(bsxfun(@minus,log(paramat(:,3:4)),log(para0(3:4))).^2,1));
bias01 = mean(bsxfun(@minus,log(paramat1(:,3:4)),log(para0(3:4))),1);
sd01 = sqrt(mean(bsxfun(@minus,log(paramat1(:,3:4)),log(para0(3:4))).^2,1));
bias02 = mean(bsxfun(@minus,log(paramat2(:,3:4)),log(para0(3:4))),1);
sd02 = sqrt(mean(bsxfun(@minus,log(paramat2(:,3:4)),log(para0(3:4))).^2,1));
bias03 = mean(bsxfun(@minus,log(paramat3(:,3:4)),log(para0(3:4))),1);
sd03 = sqrt(mean(bsxfun(@minus,log(paramat3(:,3:4)),log(para0(3:4))).^2,1));
tabl03 = [bias00' sd00' bias01' sd01' 
          bias02' sd02' bias03' sd03'];

      
save res11

