clc
clear

% parallel setting
%Due to huge amount of computation, it is wise to use 
%more than 50 opretors for parallel computing

%c = parpool('local',30);
%parpool(16)
%matlabpool local 12

% load data
load data31

Pint = [2 3 4 5];
R = 10;
Nn = length(Nsamp);
Np = length(Pint);

paratemp1 = cell(Np,niter);
paratemp2 = paratemp1;
paratemp3 = paratemp1;
paratemp4 = paratemp1;
paratemp5 = paratemp1;
paratemp6 = paratemp1;

options = zeros(1,2);
options(1) = 1000;
options(2) = 1e-6;
parfor t=1:niter
    %t
  %random sample
  data1 = datamat1(t,:);
  data2 = datamat2(t,:);
  data3 = datamat3(t,:);
  
  for m=1:Np
      Logmax = - realmax.*ones(6,1);
      pm = Pint(m);
      
      for k=1:R
          mixint = initsn4(mix0, pm); 
   
          % n=100
         [Logl, Mix, Nit, Lld] = snmem(data1, mixint, options);
         if Logl > Logmax(1)
            paratemp1{m,t} = Mix;
            Logmax(1) = Logl;
         end
        [pLogl, pMix, pNit, pLld] = plmesnmg(data1, mixint, options);
         if pLogl > Logmax(2)
            paratemp2{m,t} = pMix;
            Logmax(2) = pLogl;
         end
        
        % n=200
        [Logl1, Mix1, Nit1, Lld1] = snmem(data2, mixint, options);
        if Logl1 > Logmax(3)
           paratemp3{m,t} = Mix1;
           Logmax(3) = Logl1;
         end
        [pLogl1, pMix1, pNit1, pLld1] = plmesnmg(data2, mixint, options);
        if pLogl1 > Logmax(4)
           paratemp4{m,t} = pMix1;
           Logmax(4) = pLogl1;
        end
        
         % n=500
        [Logl2, Mix2, Nit2, Lld2] = snmem(data3, mixint, options);
        if Logl2 > Logmax(5)
           paratemp5{m,t} = Mix2;
           Logmax(5) = Logl2;
        end
        [pLogl2, pMix2, pNit2, pLld2] = plmesnmg(data3, mixint, options);
        if pLogl2 > Logmax(6)
           paratemp6{m,t} = pMix2;
           Logmax(6) = pLogl2;
        end
        
      end
  end
end
 

% degeneracy
parad1 = zeros(length(Pint), 6);
parad2 = parad1;
for h=1:length(Pint) 
    for u=1:niter
       parad1(h,1) = parad1(h,1) + sum(paratemp1{h,u}.sig<=1e-10);
       parad1(h,2) = parad1(h,2) + sum(abs(paratemp1{h,u}.lam)>=100);
       parad1(h,3) = parad1(h,3) + sum(paratemp3{h,u}.sig<=1e-10);
       parad1(h,4) = parad1(h,4) + sum(abs(paratemp3{h,u}.lam)>=100);
       parad1(h,5) = parad1(h,5) + sum(paratemp5{h,u}.sig<=1e-10);
       parad1(h,6) = parad1(h,6) + sum(abs(paratemp5{h,u}.lam)>=100);

       parad2(h,1) = parad2(h,1) + sum(paratemp2{h,u}.sig<=1e-10);
       parad2(h,2) = parad2(h,2) + sum(abs(paratemp2{h,u}.lam)>=100);
       parad2(h,3) = parad2(h,3) + sum(paratemp4{h,u}.sig<=1e-10);
       parad2(h,4) = parad2(h,4) + sum(abs(paratemp4{h,u}.lam)>=100);
       parad2(h,5) = parad2(h,5) + sum(paratemp6{h,u}.sig<=1e-10);
       parad2(h,6) = parad2(h,6) + sum(abs(paratemp6{h,u}.lam)>=100);
    end     
end

% max and min value
mmv = realmax.*[-1 -1 -1;1 1 1];
for ha=1:length(Pint) 
    for ua=1:niter
        Mmu = [paratemp1{ha,ua}.mu paratemp2{ha,ua}.mu paratemp3{ha,ua}.mu...
            paratemp4{ha,ua}.mu paratemp5{ha,ua}.mu paratemp6{ha,ua}.mu];
        mum1 = max(max(Mmu));
        mum2 = min(min(Mmu));
        if mum1>mmv(1,1)
            mmv(1,1) = mum1;
        end
        if mum2<mmv(2,1)
            mmv(2,1) = mum2;
        end
        
        Msig = [paratemp1{ha,ua}.sig paratemp2{ha,ua}.sig paratemp3{ha,ua}.sig...
            paratemp4{ha,ua}.sig paratemp5{ha,ua}.sig paratemp6{ha,ua}.sig];
        sigm1 = max(max(Msig));
        sigm2 = min(min(Msig));
        if sigm1>mmv(1,2)
            mmv(1,2) = sigm1;
        end
        if sigm2<mmv(2,2)
            mmv(2,2) = sigm2;
        end
        
        Mlam = [paratemp1{ha,ua}.lam paratemp2{ha,ua}.lam paratemp3{ha,ua}.lam...
            paratemp4{ha,ua}.lam paratemp5{ha,ua}.lam paratemp6{ha,ua}.lam];
        lamm1 = max(max(Mlam));
        lamm2 = min(min(Mlam));
        if lamm1>mmv(1,3)
            mmv(1,3) = lamm1;
        end
        if lamm2<mmv(2,3)
            mmv(2,3) = lamm2;
        end
    end
end

save res31
