function Res = randsn(N, theta)
% generate pseudorandom numbers from Skew normal distribution
% theta = (mu, lambda, sigma^2)
% SN(mu,lambda,sigma^2) = mu + sigma*(t*|N| +sqrt(1-t^2)N)
% t=lambda/sqrt(1+lambda^2)

del = theta(2)/sqrt(1+theta(2)^2);
Res = theta(1).*ones(N,1) + sqrt(theta(3))*del.*abs(randn(N,1)) ...
    +  sqrt(theta(3))*sqrt(1-del^2).*randn(N,1);
