function res = randsnm(Nsamp, mix)
% random sample of skew normal mixtures
% theta = (mu, lambda, sigma^2)
% SN(mu,lambda,sigma^2) = mu + sigma*(t*|N| +sqrt(1-t^2)N)
% t=lambda/sqrt(1+lambda^2)

res = zeros(1,Nsamp);
sumn = 0;

for n=1:mix.order
    
    if n<mix.order
        Nt = round(Nsamp.*mix.pi(n));
    else
       Nt = Nsamp - sumn; 
    end
    
    del = mix.lam(n)/sqrt(1+mix.lam(n)^2);
    res(sumn+1:sumn+Nt) = mix.mu(n) + sqrt(mix.sig(n))*del.*abs(randn(1,Nt)) ...
    + sqrt(mix.sig(n))*sqrt(1-del^2).*randn(1,Nt);
    sumn = sumn + Nt;
end
