function mix = gmminit(data, K)
% initialize the parameters of Gaussian mixtures;
% data is 1*n vector;
% K is the mixture order;

mix.order = K;
% with K-means
options = zeros(1, 18);
options(5) = 1;	
options(14) = 5;

[centres, options, post] = kmeans(data', K, options);
while rank(post)<K
    [centres, options, post] = kmeans(data', K, options);
end
mix.mu = centres;
mix.pi = sum(post,1)'./size(data,2);

Sigma = zeros(K,1);
for i=1:K
    mt = data(post(:,i)==1)-centres(i);
    nt = sum(post(:,i),1);
    Sigma(i)  = sum(mt.^2)/nt;
end
mix.sig = Sigma;

