function mix = initsn1(data, K)
% initialize the parameters of sn mixtures;
% data is 1*N vector;
% K is the mixture order;

mix.order = K;

% with K-means
options = zeros(1, 18);
options(5) = 1;	
options(14) = 5;
[centres, options, post] = kmeans(data', K, options);
while rank(post)<K
    [centres, options, post] = kmeans(data', K, options);
end
mix.pi = sum(post,1)'./size(data,2);

m2 = zeros(K,1);
m3 = m2;
for i=1:K
    mt = data(post(:,i)==1)-centres(i);
    nt = sum(post(:,i),1);
    m2(i,1) = sum(mt.^2,2)/nt;
    m3(i,1) = sum(mt.^3,2)/nt;
end

% initialize with moment estimator
mix.lam = sign(m3); 
mix.sig = m2./(1-1/pi);
mix.mu = centres - mix.lam.*sqrt(mix.sig)./sqrt(pi);








